unit Utils;

interface

uses Forms, Graphics, ShellAPI, Windows, SysUtils;

type
  TFormPos  = Record
    ws:       TWindowState;
    top,
    left,
    width,
    height:   Integer;
  end;

procedure Delay(n: Integer);

function TimeZoneBias: TDateTime;

function GetStringFromIniFile(const FileName, SectName, KeyName, Default: String): String;
function WriteStringToIniFile(const FileName, Sectname, KeyName, Value: String): Boolean;

implementation

function StrAdj(const str: string): string;
begin
  Result := str;
	SetLength(Result,StrLen(PChar(str)));
end;

procedure Delay(n: Integer);
var
	start: Integer;
begin
	start := GetTickCount;
  repeat
    Application.ProcessMessages;
	until (GetTickCount - start) >= n;
end;

function TimeZoneBias: TDateTime;
var
	TZInfo: TTimeZoneInformation;
  Bias: Integer;
const
	TIME_ZONE_ID_STANDARD = 1;
	TIME_ZONE_ID_DAYLIGHT = 2;
begin
	case GetTimeZoneInformation(TZInfo) of
	TIME_ZONE_ID_STANDARD:	Bias := TZInfo.StandardBias + TZInfo.Bias;
	TIME_ZONE_ID_DAYLIGHT:  Bias := TZInfo.DaylightBias + TZInfo.Bias;
	else
		Bias := TZInfo.Bias;
	end;
  Result := Bias / 1440; 
end;

function GetStringFromIniFile(const FileName, SectName, KeyName, Default: String): String;
begin
  SetLength(Result,2048);
  GetPrivateProfileString(PChar(SectName),PChar(KeyName),PChar(Default),PChar(Result),2048,PChar(FileName));
  Result := StrAdj(Result);
end;

function WriteStringToIniFile(const FileName, Sectname, KeyName, Value: String): Boolean;
begin
	Result := WritePrivateProfileString(PChar(Sectname),PChar(KeyName),PChar(Value),PChar(FileName));
end;

end.
