unit psk31core;

interface

uses Windows, Messages;

type
	// Data types used by the DLL
	TFFTData = array[0 .. 1023] of integer;
  PFFTData = ^TFFTData;

  TVectorData = array[0 .. 15] of integer;
  PVectorData = ^TVectorData;

  TPeakData = array[0 .. 4] of integer;
  PPeakData = ^TPeakData;

  TSyncData = array[0 .. 15] of integer;
  PSyncData = ^TSyncData;

	TRawData = array[0 .. 2047] of integer;
  PRawData = ^TRawData;

const
	// Windows messages sent by the DLL
	MSG_DATARDY = WM_USER+1000;					// Sent whenever FFT or raw data available from the soundcard
  MSG_PSKCHARRDY = WM_USER+1001;			// Sent whenever a character has been received or sent
  MSG_STATUSCHANGE = WM_USER + 1002;  // Sent whenever a status change occurs in the DLL
  MSG_IMDRDY = WM_USER + 1003;				// Sent when an IMD reading has been calculated
  MSG_CLKERR = WM_USER + 1004;				// Sent when a sound card clock error has been calculated

//  Function prototypes for the PSKCORE DLL
//  =======================================
//
//  Initialization / shutdown functions
//
		function fnStartSoundCard(h_Wnd: hWnd; cardnum, numRXchannels: integer): integer; stdcall;  external 'pskcore.dll';
		procedure fnStopSoundCard; stdcall;  external 'pskcore.dll';
//
//	Receive functions
//
		procedure fnSetRXFrequency(freq, range, channel: integer); stdcall; external 'pskcore.dll';
		procedure fnSetRXPSKMode(mode, chan: integer); stdcall; external 'pskcore.dll';
		function fnGetRXFrequency(channel: integer): integer; stdcall; external 'pskcore.dll';
		procedure fnSetFFTMode(ave, maxscale, mode: integer); stdcall; external 'pskcore.dll';
		function fnGetFFTData(DataArray: PFFTData; startpos, endpos: integer): boolean; stdcall;  external 'pskcore.dll';
    procedure fnGetFFTPeaks(PeakArray: PPeakData; startpos, endpos : integer); stdcall; external 'pskcore.dll';
		procedure fnGetSyncData(SyncArray: PSyncData; channel: integer); stdcall; external 'pskcore.dll';
    procedure fnGetVectorData(VectorArray: PVectorData; channel: integer); stdcall; external 'pskcore.dll';
    function fnGetRawData(DataArray: PRawData; startpos, endpos: integer): integer; stdcall; external 'pskcore.dll';
    procedure fnSetAFCLimit(limit, channel: integer); stdcall; external 'pskcore.dll';
    procedure fnSetSquelchThreshold(thresh, mode, channel: integer); stdcall; external 'pskcore.dll';
    function fnGetSignalLevel(channel: integer): integer; stdcall; external 'pskcore.dll';
//
//  Transmit functions
//
		procedure fnStartTX(mode: integer); stdcall; external 'pskcore.dll';
    procedure fnStopTX; stdcall; external 'pskcore.dll';
    procedure fnAbortTX; stdcall; external 'pskcore.dll';
    procedure fnSetTXFrequency(freq: integer); stdcall; external 'pskcore.dll';
    procedure fnSetCWIDString(lpszIDStrg: PChar); stdcall; external 'pskcore.dll';
    function fnSendTXCharacter(txchar, cntrl: integer): integer; stdcall; external 'pskcore.dll';
    procedure fnSendTXString(lpszTXStrg: PChar); stdcall; external 'pskcore.dll';
    function fnGetTXCharsRemaining: integer; stdcall; external 'pskcore.dll';
    procedure fnClearTXBuffer; stdcall; external 'pskcore.dll';
    procedure fnSetCWIDSpeed(speed: integer); stdcall; external 'pskcore.dll';
    function fnSetComPort(portnum, mode: integer): boolean; stdcall; external 'pskcore.dll';
//
//  Miscellaneous functions
		procedure fnSetClockErrorAdjustment(ppm: integer); stdcall; external 'pskcore.dll';
		function fnGetDLLVersion: integer; stdcall; external 'pskcore.dll';

implementation

end.
